#!/bin/bash

if [ $# -eq 0 ]
then
  echo ""
  echo "Usage: $0 models skip"
  echo "models is a file containing the information 
needed to construct each model. Its format is:
model_name1 num_states1 w1 w2 ... wn
model_name2 num_states2 w1 w2 ... wn
...

skip is an integer indicating the number of skips.
See example for more information.
"
  exit
fi

awk -v t=$2 -v r=$RANDOM '
BEGIN {
  srand(r);
}
{
  n = split($0, a);
  neti = n - 2;
  nest = a[2];
  printf("HMM %s 0 %d %d\n",a[1],nest,neti);
  for (i=0; i<nest; i++)
    printf(" %e",0.0);
  printf("\n");
  for (i=0; i<nest; i++) {
    for (j=0; j<i; j++)
      v[j] = 0.0;
    suma = 0.0;
    for (;j<(i+2+t>nest+1?nest+1:i+2+t);j++) {
      v[j] = rand();
      suma += v[j];
    }
    for (;j<nest+1;j++)
      v[j] = 0.0;
    for (j=0; j<nest+1; j++)
      printf(" %e",v[j] / suma);
    printf("\n");
  }
  for (j=0; j<nest; j++)
    suma2[j] = 0.0;
  for (i=0; i<neti; i++) {
    for (j=0; j<nest; j++) {
      v[i*nest+j] = rand();
      suma2[j] += v[i*nest+j];
    }
  }
  for (i=0; i<neti; i++) {
    for (j=0; j<nest; j++)
      printf(" %f",v[i*nest+j] / suma2[j]);
    printf(" %s\n",a[i+3]);
  }
  printf("\n");
}' $1 | sed 's/,/./g'
    
