#include "imagen.h"
#include <math.h> 
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <string>
#include <string.h>
#include <iostream>
int x[]={-1,-1,-1,0,0,1,1,1};
int y[]={-1,0,1,-1,1,-1,0,1};
imagen::imagen(){
	char basura[5];
	cin>>basura;
	cin>>columnas;
	cin>>filas;
	cin>>maxValor;
	for(int i=0;i<filas*columnas;i++){
		int elem;
		cin>>elem;
		datos.push_back(elem);
	}
}

imagen::imagen(string name){
	ifstream fe;
	fe.open(name.c_str());
	if(fe.is_open()){
		char basura[5];
		fe>>basura;
		fe>>columnas;
		fe>>filas;
		fe>>maxValor;
		for(int i=0;i<filas*columnas;i++){
			int elem;
			fe>>elem;
			datos.push_back(elem);
		}
	fe.close();
	}
	else{
		cout<<"el fichero: "<<name<<" no ha ido habierto\n";
	}
}
void imagen::binarizar(int margen){
		for(int i=0;i<filas*columnas;i++){
			if(datos[i]>margen){
				datos[i]=255;
			}
			else{
				datos[i]=0;
			}
			
		}
}
void imagen::guardarImagen(string name){
	ofstream fs;
	fs.open(name.c_str(), ofstream::out);
	fs<<"P2\n";
	fs<<columnas<<" ";
	fs<<filas<<"\n";
	fs<<maxValor<<"\n";
	for(int i=0;i<filas;i++){
		for(int j=0;j<columnas;j++){
				fs<<datos[i*columnas+j]<<" ";
		}	
		fs<<endl;
	}
	fs.close();

}
void imagen::guardarImagen(){
	cout<<"P2\n";
	cout<<columnas<<" ";
	cout<<filas<<"\n";
	cout<<maxValor<<"\n";
	for(int i=0;i<filas;i++){
		for(int j=0;j<columnas;j++){
				cout<<datos[i*columnas+j]<<" ";
		}	
		cout<<endl;
	}
}
void imagen::recortarFinal(int margenCol,int margenFil){
	int fil,col;
	int fixi,fixj;
	maxValor=1;
	margenCol=(margenCol/2)*2;
	margenFil=(margenFil/2)*2;
	//buscando el final de laimagen
	for(int j=columnas-1;j>=0;j--){
		for(int i=filas-1;i>=0;i--){
			//cout<<i<<" "<<j<<endl;
			if(datos[i*columnas+j]==0){
				fixi=i;
				fixj=j;
				i=-1;
				j=-1;
				break;
			}
		}	
	}

	for(int i=filas-1;i>=0;i--){
		for(int j=fixj;j>=fixj-margenCol;j--){
			//cout<<i<<" "<<j<<endl;
			if(datos[i*columnas+j]==0){
				fixi=i;
				i=-1;
				j=-1;
				break;
			}
		}	
	}

	//cout<<fixi<<" "<<fixj<<endl;
	//recortando el trozo final
	int tam=margenFil*margenCol;
	vector<int> dat;
	dat.resize(tam+2);
	for(int i=0;i<tam;i++) dat[i]=maxValor;
	int cont=0;

	for(int i=(fixi-margenFil)+1;i<=fixi;i++){
		for(int j=(fixj-margenCol)+1;j<=fixj;j++){
			//cerr<<i-((fixi-margenFil)+1)<<" "<<j-((fixj-margenCol)+1)<<" "<<cont<<endl;
			if(j<columnas && i<filas &&j>=0 && i>=0){
				dat[cont]=datos[i*columnas+j]/255;
			}	
			cont++;
		}
	}
	filas=margenFil;
	columnas=margenCol;
	datos=dat;

}
void imagen::merge(imagen fin){
	//detectar final
	int i=filas/2;
	int final=0;
		for(int j=columnas;j>0;j--)
		{
			if(datos[i*columnas+j]!=255)
			{
				final=j;
				break;
			}
		}

	i=filas/2;
	int principio=0;
		for(int j=0;j<fin.columnas;j++)
		{
			if(fin.datos[i*fin.columnas+j]!=255)
			{
				principio=j;
				break;
			}
		}
	//cout<<final<<" "<<principio<<endl;
	int newFil=filas>fin.filas?filas:fin.filas;
	int newCol=final+(fin.columnas-principio);
	vector<int> newdatos;
	newdatos.resize(newFil*newCol);
	for(int i=0;i<newFil;i++)
	{
		for(int j=0;j<newCol;j++)
		{
			if(j<final)
				newdatos[i*newCol+j]=getDato(i,j);
			else
				newdatos[i*newCol+j]=fin.getDato(i,(j-final)+(principio));
		}
	}
	filas=newFil;
	columnas=newCol;
	datos=newdatos;
}
int imagen::getDato(int i, int j)
{
	if(j<columnas && i<filas &&j>=0 && i>=0)
	{
		return datos[i*columnas+j];
	}
	else
		return maxValor;	
}
void imagen::recortarContorno()
{
	int fixi,fixj;
	for(int i=filas-1;i>0;i--)
	{
		bool contorno=true;
		for(int j=0;j<columnas;j++)
		{
			if(datos[i*columnas+j]==0)
			{
				borrarInterior(i,j);
				fixi=i;
				fixj=j;
				j=columnas+1;
				i=-1;
			}
		}	

	}
	for(int i=0;i<filas;i++)
		for(int j=0;j<columnas;j++)
		{
			if(datos[i*columnas+j]==-1)datos[i*columnas+j]=0;
			if(datos[i*columnas+j]==-2)datos[i*columnas+j]=1;
		}
	string a;
	bool seguir=true;
	int i=fixi;
	int j=fixj;
		
		while(seguir)
		{
			int k;
			datos[i*columnas+j]=1;
			for(k=0;k<8;k++)
			{
				if((i+x[k])>=0 and (i+x[k])<filas and(j+y[k])>=0 and (j+y[k])<columnas)
				{
					if(datos[(i+x[k])*columnas+(j+y[k])]==0)
					{
						i=i+x[k];
						j=j+y[k];
						a.push_back('0'+k);
						a.push_back(' ');
						k=0;
						break;
					}
				}
			}
			if(k>=8) break;
		}
		if(a.length()<1)
			cout<<"0 0 0 0 0 0 0 0 0 0\n";
		else		
			cout<<a<<endl;
}

void imagen::borrarInterior(int i, int j)
{
	bool borrar=false;
	int aux=0;
	for(int k=0;k<8;k++)
	{
		if((i+x[k])>=0 and (i+x[k])<filas and(j+y[k])>=0 and (j+y[k])<columnas)
		{
			if(datos[(i+x[k])*columnas+(j+y[k])]==1)
				aux++;
		}
		else
			aux++;
	}
	if(aux>0)
	{
		datos[i*columnas+j]=-1;
	}
	else
	{
		datos[i*columnas+j]=-2;
	}
	for(int k=0;k<8;k++)
			if((i+x[k])>=0 and (i+x[k])<filas and(j+y[k])>=0 and (j+y[k])<columnas)
				if(datos[(i+x[k])*columnas+(j+y[k])]==0)
					borrarInterior((i+x[k]),(j+y[k]));
}






